%{?filter_provides_in: %filter_provides_in %{_httpd_moddir}/.*\.so$}
%{?filter_setup}

Summary:       A WSGI interface for Python web applications in Apache
Name:          mod_wsgi
Version:       4.9.4
Release:       6%{?dist}
License:       ASL 2.0
URL:           https://modwsgi.readthedocs.io/
Source0:       https://github.com/GrahamDumpleton/mod_wsgi/archive/%{version}.tar.gz#/mod_wsgi-%{version}.tar.gz
Source1:       wsgi-python3.conf
Patch3001:     mod_wsgi-4.5.20-exports.patch

BuildRequires: httpd-devel gcc make

%description
The mod_wsgi adapter is an Apache module that provides a WSGI compliant interface for hosting Python
based web applications within Apache. The adapter is written completely in C code against the Apache
C runtime and for hosting WSGI applications within Apache has a lower overhead than using existing
WSGI adapters for mod_python or CGI.

%package -n python3-%{name}
Summary:        A WSGI interface for Python web applications in Apache
BuildRequires:  python3-devel python3-sphinx python3-sphinx_rtd_theme python3-setuptools
Requires:       httpd-mmn = %{_httpd_mmn}
Provides: mod_wsgi = %{version}-%{release}

%description -n python3-%{name}
The mod_wsgi adapter is an Apache module that provides a WSGI compliant interface for hosting Python
based web applications within Apache. The adapter is written completely in C code against the Apache
C runtime and for hosting WSGI applications within Apache has a lower overhead than using existing
WSGI adapters for mod_python or CGI.

%prep
%autosetup -p1 -n %{name}-%{version}

%build
%make_build -C docs html
export LDFLAGS="$RPM_LD_FLAGS -L%{_libdir}"
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"

mkdir py3build/
cp -R * py3build/ || :
pushd py3build
%configure \
    --enable-shared \
    --with-apxs=%{_httpd_apxs} \
    --with-python=%{python3} \
    %{nil}
%make_build
%py3_build
popd

%install
pushd py3build
%make_install LIBEXECDIR=%{_httpd_moddir}
mv  %{buildroot}%{_httpd_moddir}/mod_wsgi{,_python3}.so
install -d -m 755 %{buildroot}%{_httpd_modconfdir}
install -p -m 644 %{SOURCE1} %{buildroot}%{_httpd_modconfdir}/10-wsgi-python3.conf

%py3_install
mv %{buildroot}%{_bindir}/mod_wsgi-express{,-3}
popd

%files -n python3-%{name}
%license LICENSE
%doc CREDITS.rst README.rst
%config(noreplace) %{_httpd_modconfdir}/*wsgi-python3.conf
%{_httpd_moddir}/mod_wsgi_python3.so
%{python3_sitearch}/mod_wsgi-*.egg-info
%{python3_sitearch}/mod_wsgi
%{_bindir}/mod_wsgi-express-3

%changelog
* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.9.4-6
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.9.4-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Jul 20 2023 cunshunxia <cunshunxia@tencent.com> - 4.9.4-4
- Rebuilt for httpd 2.4.57

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.9.4-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.9.4-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Mar 6 2023 Shuo Wang <abushwang@tencent.com> - 4.9.4-1
- initial build
